$( document ).ready( function() {
	$( 'form[name="ajaxtest"]' ).on( 'submit', function( event ) {
		$( this ).doeZoekFotoos( event );
	} );
} );

// FLICKR 
$.fn.doeZoekFotoos = function( e ) {
	e.preventDefault();
	var zoeken = $( this ).children('input[name="zoek"]').val();
	var data = { tags: zoeken, tagmode: 'any', format: 'json' };
	var url = 'http://api.flickr.com/services/feeds/photos_public.gne?jsoncallback=?';
	$.ajax( {
		data: data,
		url: url,
		dataType: 'json',
		success: flickrRetour,
		error: foutje
	} );
}

// GETJSON
$.fn.doeGetJSON = function( e ) {
	e.preventDefault();
	url = 'http://jeex.eu/download/bim/jqueryretour.php?callback=?';
	$.getJSON( url, leesForm( this ), retour );
}

// JSON AJAX
$.fn.jsonAJAX = function( e ) {
	e.preventDefault();
	$.ajax( {
		data: leesForm( this ),
		type: 'POST',
		url: 'retour.php',
		dataType: 'json',
		success: retour,
		error: foutje
	} )
}

// JSONP AJAX
$.fn.jsonpAJAX = function( e ) {
	e.preventDefault();
	$.ajax( {
		data: leesForm( this ),
		type: 'GET',
		url: 'http://jeex.eu/download/bim/jqueryretour.php',
		crossDomain: true,
		dataType: 'jsonp',
		success: retour,
		error: foutje
	} );
}

// JSON- EN RETOUR FUNCTIES
function json2Html( waarde ) {
	var output = '';
	if( waarde instanceof Object ){
		output += json2HtmlDieper( waarde );
	}else{
		output += waarde;
	}
	return output;
}
function json2HtmlDieper( jsonding ) {
	var output = '<ul>';
	for( var k in jsonding ) {
		var sleutel = k;
		var waarde = json2Html( jsonding[k] );
		output += '<li>' + sleutel + ' = ' + waarde + '</li>';
	}
	output += '</ul>';
	return output;
}
function retour( terug ){
	$( 'footer' ).html( 
		'<h4>antwoord</h4>' 
		+ json2Html( terug ) + '' );
}
function foutje() {
	$( 'footer' ).html( 'Daar ging iets mis.' );
}
function leesForm( formulier ) {
	return $( formulier ).serialize();
}

// TEXT AJAX
$.fn.textAJAX = function( e ) {
	e.preventDefault();
	$.ajax( {
		type: 'POST',
		url: 'json.txt',
		dataType: 'text',
		success: textTERUG,
		error: textFOUT,
	} );
}
function textTERUG( terug ) {
	var jsonding = JSON.parse( terug );
	console.log('Success: ' + jsonding);
	$( 'footer' ).html( json2Html( jsonding ) );
}
function textFOUT( terug ) {
	console.log('Error: ' + terug)
}

// JAVASCRIPT AJAX
$.fn.jsAJAX = function( e ) {
	e.preventDefault();
	$.ajax( {
		type: 'POST',
		url: 'simpel.js',
		dataType: 'script',
		success: jsTERUG,
	} );
}
function jsTERUG( terug ) {
	// het opgehaalde script wordt direct uitgevoerd
	opgehaaldeFunctie();
}
function jsFOUT( terug ) {
	console.log('Error: ' + terug)
}

// HTML AJAX
$.fn.htmlAJAX = function( e ) {
	e.preventDefault();
	$.ajax( {
		type: 'POST',
		url: 'simpel.html',
		dataType: 'html',
		success: htmlTERUG,
	} );
}
function htmlTERUG( terug ) {
	$( 'footer' ).html( terug );
}
function htmlFOUT( terug ) {
	console.log('Error: ' + terug)
}











// VOORGEBAKKEN FUNCTIES
function flickrRetour( terug ){
	var tonen = '';
	for( var i = 0; i < terug.items.length; i++ ) {
		tonen += '<p><a href="' 
			+ terug.items[i]['link'] 
			+ '"><img class="flickrfoto" src="' 
			+ terug.items[i]['media']['m'] 
			+ '" /></a></p>';
	}
	tonen += '<div class="eindfloat"></div>';
	$( 'footer' ).html( tonen );
}

function crunchForm( form ) {
	var terug = {};
	$( form ).children('input').each( function( i, welk ) {
		if( $( welk ).attr('name') === 'alias' || $( welk ).attr('name') === 'pass' ){
			// versleutelen
			terug[$( welk ).attr('name')] = btoa( $( welk ).val() );
		}else{
			// niet versleutelen
			terug[$( welk ).attr('name')] = $( welk ).val();
		}
	} );
	return terug;
}

