$( document ).ready( function() {
	// beleg ophalen
	ajaxHaalBeleg();
	
	// valideren klantformulier
	$( '#klantgegevens input' ).on( 'change', function() {
		$( this ).valideerKlantVeld();
	} );
	
	// submit voor bestelformulier
	$( 'form[name="bestelform"]' ).on( 'submit', function( event ) {
		event.preventDefault();
		if( $( '#klantgegevens input' ).valideerKlantform() ) {
			plaatsBestelling();
		}
	} );
	
	// event voor bodem
	$( 'form[name="pizzaform"] input[name="bodemmaat"]' )
		.on( 'change' , function() {
			$( this ).bodemPizza();
		} )
	
	// deze methode wordt altijd uitgevoerd als de pagina geladen is
	$( 'form[name="pizzaform"] input[name="bodemmaat"]:checked' )
		.bodemPizza(); 
	
	// event voor bodem in bestelformulier triggert hierboven
	$( 'form[name="bestelform"] select[name="in_bodem"]' )
		.on( 'change' , function() {
			$( this ).pizzaBodem();
		} );
	
	// zoekfunctie
	$( 'form[name="pizzaform"] input[name="zoeklijst"]' )
		.on( 'keyup', function() {
			$( this ).zoekInLijsten();
		} )
} );

// ZOEKEN in LIJSTEN
$.fn.zoekInLijsten = function() {
	// zoektekst met begin hoofdletter
	var zoek = $( this ).val().trim().toLowerCase();
	
	// huidige selecties weghalen
	$( 'form[name="pizzaform"] select' )
		.removeClass( 'lijstgevonden' )
		.find( 'option' ).prop( 'selected', '' );
	 
	// nieuwe selecties aanbrengen
	if( zoek.length >= 1 ) {
		$( 'form[name="pizzaform"] option[data-zoekhulp*="' + zoek + '"]' )
			.prop( 'selected', 'selected' )
			.parent().addClass( 'lijstgevonden')
	}
}


// BELEG TOEVOEGEN AAN PIZZA
$.fn.voegBelegToe = function() {
	// de groep waarin deze (this) knop Voeg toe zit
	var groep = $( this ).parent();
	// gekozen ingrediënt
	var product = groep.find( 'select option:selected' );
	var naam = product.val()
	var ingredient = product.text();
	var prijs = product.data( 'prijs' );
	// dubbele portie?
	var dubbel = 1;
	if( groep.find( 'input[type="checkbox"]' )
	   .prop( 'checked' ) ) {
			dubbel = 2;
			prijs = prijs * 2;
	}

	// nieuwe div wrapper maken met id van productnaam
	var div = document.createElement( 'div' );
	$( div ).attr( 'id', 'div_' + naam );
	
	// veld ingredientnaam
	var veld = document.createElement( 'input' );
	$( veld )
		.attr( 'type', 'text' )
		.attr( 'name', 'in_' + naam )
		.attr( 'readonly', 'readonly')
		.data( 'val', ingredient )
		.val( ingredient )
		.addClass( 'belegveld' )
		.appendTo( $( div ) );

	// veld dubbele portie
	var veld = document.createElement( 'input' );
	$( veld )
		.attr( 'type', 'checkbox' )
		.attr( 'name', 'dubbel_' + naam )
		.prop( 'checked', ( dubbel === 2 ) )
		.addClass( 'belegveld' )
		.attr( 'onclick', 'return false;' )
		.appendTo( $( div ) );
	
	// veld prijs
	var veld = document.createElement( 'input' );
	$( veld )
		.attr( 'type', 'text' )
		.attr( 'name', 'prijs_' + naam )
		.attr( 'readonly', 'readonly')
		.data( 'val', digits2( prijs ) )
		.val( digits2( prijs ) )
		.addClass( 'prijsveld' )
		.appendTo( $( div ) );
	
	// veld verwijderen knop
	$( '<img src="./weg.png" />' )
		.appendTo( $( div ) )
		.on( 'click', function() {
			berekenTotaal();
			$( this ).parent().remove();
		} );
	
	// div wrapper in HTML-boom plaatsen
	var bf = 'form[name="bestelform"] > div#ingredienten';
	$( bf + ' > #div_' + naam ).remove();
	$( div ).appendTo( bf );
	berekenTotaal();
}
function berekenTotaal() {
	var lijst = $( 'form[name="bestelform"] > div#ingredienten input.prijsveld' );
	var totaal = Number( $( 'input[name="prijs_bodem"]' ).val() );
	$( lijst ).each( function( index ) {
		totaal += Number( $( this ).val() );
	} );
	var tf = 'form[name="bestelform"] input[name="klant_prijs"]';
	$( tf ).val( digits2( totaal ) );
}


// BELEG OPHALEN NA OPENEN WEBPAGINA
function ajaxHaalBeleg() {
	// ajax
	$.ajax( {
		type: 'GET',
		url: 'http://download.jeex.eu/bim/jquerybeleg.php',
		crossDomain: true,
		dataType: 'jsonp'
	} )
	.done( function( terug ) {
		htmlMaakGroepen( terug );
	} );
}
function htmlMaakGroepen( beleg ) {
	for( var groep in beleg ) {
		// naam van de groep
		var cGroep = hoofdletter( groep );
		
		// HTML-blok voor groep
		var lap = '<p><label>' 
			+ cGroep
			+ '</label><select class="belegveld" name="select_' 
			+ groep + '"></select><span class="belegveld"><input type="checkbox" name="extra_' 
			+ groep + '" value="2" >Dubbel</span> <input class="prijsveld"  type="button" name="' 
			+ groep + '" value="Voeg toe" ></p>';
		$( '#ingredientenlijst' ).append( lap );
		
		// inhoud van de groep toevoegen aan select lijst
		$( 'form[name="pizzaform"] select[name="select_' + groep + '"]' )
			.htmlMaakOpties( beleg[groep] );
	}
	// voor alle knoppen een klik-event maken om toe te voegen aan pizza
	$( 'form[name="pizzaform"] input[type="button"]' ).
		on( 'click', function() {
			$( this ).voegBelegToe();
		} );
}

// plaats options binnen de select
$.fn.htmlMaakOpties = function( groep ) {
	// alle ingredienten in groep itereren
	for( var ingr in groep ) {
		// html options toevoegen
		var optie = document.createElement( 'option' );
		$( optie )
			.val( ingr )
			.text( groep[ingr]['naam'] )
			.data( 'prijs', groep[ingr]['prijs'] )
			.attr( 'data-zoekhulp', groep[ingr]['naam'].toLowerCase() )
			.attr( 'data-prijs', groep[ingr]['prijs'] )
			.appendTo( $( this ) );
		
		// ingredient ook in zoek datalijst
		$( 'form[name="pizzaform"] #zoeklijst' )
			.append( '<option value="' + groep[ingr]['naam'] + '">' ); 
			}
}


// BODEM KIEZEN
$.fn.bodemPizza = function() {	
	// shortcuts naar formulieren
	var bf = 'form[name="bestelform"]';
	
	// bodemmaat en prijs ophalen
	var bodem = $( this ).val();
	var prijs = $( this ).data( 'prijs' );
	prijs = digits2( prijs );
	
	// juiste option in afrolmenu bestelform kiezen
	$( bf + ' select[name="in_bodem"]' ).val( bodem );
		
	// juiste prijs in bestelform instellen
	$( bf + ' input[name="prijs_bodem"]' ).val( prijs );
	berekenTotaal();
}

$.fn.pizzaBodem = function() {
	// shortcuts naar formulieren
	var pf = 'form[name="pizzaform"] ';
	
	// radioknoppen wijzigen
	var bodem = $( this ).val();
	$( pf + ' input:radio[name="bodemmaat"][value="' + bodem + '"]')
		.prop('checked', true);

	// dan de radioknopp event triggeren
	$( pf + ' input[name="bodemmaat"]' )
		.trigger( 'change' );
}






// BESTELLING PLAATSEN
function plaatsBestelling() {
	// shortcut naar formulier
	var ff = $( 'form[name="bestelform"]' ) ;
	
	// ajax
	$.ajax( {
		data: ff.serialize(),
		type: 'GET',
		url: 'http://download.jeex.eu/bim/jqueryretour.php?prevent=1',
		crossDomain: true,
		dataType: 'jsonp',
		success: retour,
		error: foutje
	} );
}

// INVOER VALIDEREN en KUISEN
$.fn.valideerKlantform = function() {
	// hele formulier itereren
	$( this ).each( function( index ) {
		$( this ).valideerKlantVeld();
	} );
	// alleen als geen enkel veld fout is
	return $( '.valideerfout' ).length === 0;
}

$.fn.valideerKlantVeld = function() {
	// type veld kiezen voor juiste validatie
	if( $( this ).attr( 'type' ) === 'text' ) {
		// tekst
		if( valideerTekst( $( this ).val() ) ) {
			$( this ).removeClass( 'valideerfout' );
		}else{
			$( this ).addClass( 'valideerfout' );
		}
	}else if( $( this ).attr( 'type' ) === 'email' ) {
		// email
		if( valideerMail( $( this ).val() ) ) {
			$( this ).removeClass( 'valideerfout' );
		}else{
			$( this ).addClass( 'valideerfout' );
		}
	}else if( $( this ).attr( 'type' ) === 'tel' ) {
		// telefoon
		if( valideerTel( $( this ).val() ) ) {
			$( this ).removeClass( 'valideerfout' );
		}else{
			$( this ).addClass( 'valideerfout' );
		}
	}
}
function valideerMail( erin ) {
	var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test( erin );
}
function valideerTekst( erin ) {
	var re = /^[a-zA-Z0-9 ]*$/;
    return re.test( erin ) && ( erin.length > 2 );
}
function valideerTel( erin ) {
	var re = /\d/;
	return re.test( erin ) && ( erin.length > 9 );
}




// JSON FUNCTIES
function json2Html( waarde ) {
	var output = '';
	if( waarde instanceof Object || waarde instanceof Array ){
		output += json2HtmlDieper( waarde );
	}else{
		output += waarde;
	}
	return output;
}
function json2HtmlDieper( jsonding ) {
	var output = '<ul>';
	for( var k in jsonding ) {
		var sleutel = k;
		var waarde = json2Html( jsonding[k] );
		output += '<li>' + sleutel + ' = ' + waarde + '</li>';
	}
	output += '</ul>';
	return output;
}
function retour( terug ){
	// output
	$( 'footer' ).html( 
		'<h4>antwoord</h4>' 
		+ json2Html( terug ) + '' );
}
function foutje() {
	$( 'footer' ).html( 'Daar ging iets mis.' );
}


// Begin hoofdletter
function hoofdletter( erin ) {
	return erin.charAt(0).toUpperCase() + erin.slice(1);
}

// zorgt voor een getal met 2 digits
function digits2( erin ) {
	erin = Number( erin );
	return erin.toFixed(2);
}

